Subject: Re: [PATCH net-next v20 02/14] net: ethtool: Introduce ETHTOOL_LINK_MEDIUM_* values

From: "Russell King (Oracle)" <[email-masked]>
Date: Thu, 27 Nov 2025 18:02:28 +0000

On Thu, Nov 27, 2025 at 06:17:45PM +0100, Maxime Chevallier wrote:
> In an effort to have a better representation of Ethernet ports,
> introduce enumeration values representing the various ethernet Mediums.
> 
> This is part of the 802.3 naming convention, for example :
> 
> 1000 Base T 4
>  |    |   | |
>  |    |   | \_ pairs (4)
>  |    |   \___ Medium (T == Twisted Copper Pairs)
>  |    \_______ Baseband transmission
>  \____________ Speed
> 
>  Other example :
> 
> 10000 Base K X 4
>            | | \_ lanes (4)
>            | \___ encoding (BaseX is 8b/10b while BaseR is 66b/64b)
>            \_____ Medium (K is backplane ethernet)
> 
> In the case of representing a physical port, only the medium and number
> of pairs should be relevant. One exception would be 1000BaseX, which is
> currently also used as a medium in what appears to be any of
> 1000BaseSX, 1000BaseCX and 1000BaseLX. This was reflected in the mediums
> associated with the 1000BaseX linkmode.

There's more than just those three for 1000BASE-X:
	SX
	LX
	CX
	EX
	BX10 - single fibre strand, single mode, 1310nm and 1490nm over
		10km.

to name a few more. SFP modules don't have a way to indicate EX, but do
have a way to indicate 1000BASE-BX10 (BaseBX10 bit set with the rate
indicating 1000M.)

Also note that 100BASE-T encompasses 100BASE-TX (what we generally see
as fast ethernet), 100BASE-T4, etc. Should we be getting these
descriptions correct as we're introducing this level of detail?

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!